package party.bami.eqfix.fragment;

import android.Manifest;
import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.SeekBar;

import java.io.IOException;

import party.bami.eqfix.EQView;
import party.bami.eqfix.R;
import party.bami.eqfix.analysis.PresetEmptyException;
import party.bami.eqfix.analysis.PresetInvalidFileException;
import party.bami.eqfix.preset.EQFPreset;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link AnalysisFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link AnalysisFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class EQFragment extends Fragment {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    private OnFragmentInteractionListener mListener;

    // Seek bar values.
    public float bass;
    public float mid;
    public float treble;

    private EQView eqView;

    private EQFPreset preset;


    public EQFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment AnalysisFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static EQFragment newInstance(String param1, String param2) {
        EQFragment fragment = new EQFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }

        this.preset = new EQFPreset(EQFragment.this.getContext());
        try {
            preset.load("test.eqf");
        } catch (PresetInvalidFileException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        this.bass = this.preset.getParams()[0];
        this.mid = this.preset.getParams()[1];
        this.treble = this.preset.getParams()[2];
    }

    private View inflatedView = null;

    /* Returns the current inflatedView so an other thread can draw to it. */
    public View getInflatedView() {
        return inflatedView;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        this.inflatedView = inflater.inflate(R.layout.fragment_eqset, container, false);
        this.eqView = (EQView) inflatedView.findViewById(R.id.eqView);

        // Seek bar handlers
        final SeekBar sbBass = (SeekBar) inflatedView.findViewById(R.id.sBass);
        sbBass.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                EQFragment.this.bass = progressToAmp(progress);
                EQFragment.this.update();
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {}

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {}
        });

        final SeekBar sbMid = (SeekBar) inflatedView.findViewById(R.id.sMid);
        sbMid.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                EQFragment.this.mid = progressToAmp(progress);
                EQFragment.this.update();
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {}

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {}
        });

        final SeekBar sbTreble = (SeekBar) inflatedView.findViewById(R.id.sTreble);
        sbTreble.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                EQFragment.this.treble = progressToAmp(progress);
                EQFragment.this.update();
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {}

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {}
        });

        // Save button
        final Button buttonWR = (Button) inflatedView.findViewById(R.id.buttonSave);
        buttonWR.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EQFragment.this.savePreset();
            }
        });

        // Inflate the layout for this fragment
        return inflatedView;
    }

    private float progressToAmp(float progress) {
        return (progress - 50) / 50;
    }

    public void update() {
        this.eqView.updateView(this.bass, this.mid, this.treble);
    }

    public void savePreset() {
        this.preset.setParams(this.bass, this.mid, this.treble);
        try {
            this.preset.save("test.eqf");
        } catch (PresetEmptyException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }
}
